

// This C++ file was created by SanEditor

#include "Atomic/Adjudicator/AdjudicatorSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         AdjudicatorSAN Constructor             
******************************************************************/


AdjudicatorSAN::AdjudicatorSAN(){


  Activity* InitialActionList[4]={
    &System_OK_Act, //0
    &System_SS_Act, //1
    &System_US_Act, //2
    &Common_failure  // 3
  };

  BaseGroupClass* InitialGroupList[4]={
    (BaseGroupClass*) &(Common_failure), 
    (BaseGroupClass*) &(System_OK_Act), 
    (BaseGroupClass*) &(System_SS_Act), 
    (BaseGroupClass*) &(System_US_Act)
  };

  CH1_OK = new Place("CH1_OK" ,1);
  CH2_OK = new Place("CH2_OK" ,1);
  CH1_Safe_Failure = new Place("CH1_Safe_Failure" ,0);
  CH1_US_Failure = new Place("CH1_US_Failure" ,0);
  CH2_Safe_Failure = new Place("CH2_Safe_Failure" ,0);
  CH2_US_Failure = new Place("CH2_US_Failure" ,0);
  System_OK = new Place("System_OK" ,1);
  System_Safe_Failure = new Place("System_Safe_Failure" ,0);
  System_Unsafe_State = new Place("System_Unsafe_State" ,0);
  CCF_active = new Place("CCF_active" ,0);
  CCF_enabler = new Place("CCF_enabler" ,CC_enabler);
  BaseStateVariableClass* InitialPlaces[11]={
    CH1_OK,  // 0
    CH2_OK,  // 1
    CH1_Safe_Failure,  // 2
    CH1_US_Failure,  // 3
    CH2_Safe_Failure,  // 4
    CH2_US_Failure,  // 5
    System_OK,  // 6
    System_Safe_Failure,  // 7
    System_Unsafe_State,  // 8
    CCF_active,  // 9
    CCF_enabler   // 10
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Adjudicator", 11, InitialPlaces, 
                        0, InitialROPlaces, 
                        4, InitialActionList, 4, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[10][2]={ 
    {6,0}, {7,0}, {8,0}, {6,1}, {7,1}, {8,1}, {6,2}, {7,2}, {8,2}, 
    {9,3}
  };
  for(int n=0;n<10;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[18][2]={ 
    {0,0}, {1,0}, {6,0}, {0,1}, {1,1}, {7,1}, {2,1}, {4,1}, {6,1}, 
    {0,2}, {1,2}, {2,2}, {4,2}, {8,2}, {0,3}, {1,3}, {6,3}, {10,3}
  };
  for(int n=0;n<18;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<4;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void AdjudicatorSAN::CustomInitialization() {

}
AdjudicatorSAN::~AdjudicatorSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void AdjudicatorSAN::assignPlacesToActivitiesInst(){
  System_OK_Act.CH1_OK = (Place*) LocalStateVariables[0];
  System_OK_Act.CH2_OK = (Place*) LocalStateVariables[1];
  System_OK_Act.System_OK = (Place*) LocalStateVariables[6];
  System_OK_Act.System_Safe_Failure = (Place*) LocalStateVariables[7];
  System_OK_Act.System_Unsafe_State = (Place*) LocalStateVariables[8];
  System_SS_Act.CH1_OK = (Place*) LocalStateVariables[0];
  System_SS_Act.CH2_OK = (Place*) LocalStateVariables[1];
  System_SS_Act.System_Safe_Failure = (Place*) LocalStateVariables[7];
  System_SS_Act.CH1_Safe_Failure = (Place*) LocalStateVariables[2];
  System_SS_Act.CH2_Safe_Failure = (Place*) LocalStateVariables[4];
  System_SS_Act.System_OK = (Place*) LocalStateVariables[6];
  System_SS_Act.System_Unsafe_State = (Place*) LocalStateVariables[8];
  System_US_Act.CH1_OK = (Place*) LocalStateVariables[0];
  System_US_Act.CH2_OK = (Place*) LocalStateVariables[1];
  System_US_Act.CH1_Safe_Failure = (Place*) LocalStateVariables[2];
  System_US_Act.CH2_Safe_Failure = (Place*) LocalStateVariables[4];
  System_US_Act.System_Unsafe_State = (Place*) LocalStateVariables[8];
  System_US_Act.System_OK = (Place*) LocalStateVariables[6];
  System_US_Act.System_Safe_Failure = (Place*) LocalStateVariables[7];
}
void AdjudicatorSAN::assignPlacesToActivitiesTimed(){
  Common_failure.CH1_OK = (Place*) LocalStateVariables[0];
  Common_failure.CH2_OK = (Place*) LocalStateVariables[1];
  Common_failure.System_OK = (Place*) LocalStateVariables[6];
  Common_failure.CCF_enabler = (Place*) LocalStateVariables[10];
  Common_failure.CCF_active = (Place*) LocalStateVariables[9];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================System_OK_ActActivity========================*/


AdjudicatorSAN::System_OK_ActActivity::System_OK_ActActivity(){
  ActivityInitialize("System_OK_Act",1,Instantaneous , RaceEnabled, 3,3, false);
}

void AdjudicatorSAN::System_OK_ActActivity::LinkVariables(){
  CH1_OK->Register(&CH1_OK_Mobius_Mark);
  CH2_OK->Register(&CH2_OK_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  System_Safe_Failure->Register(&System_Safe_Failure_Mobius_Mark);
  System_Unsafe_State->Register(&System_Unsafe_State_Mobius_Mark);
}

bool AdjudicatorSAN::System_OK_ActActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((((CH1_OK->Mark() != 0) || (CH2_OK->Mark() != 0)) && (System_OK->Mark() == 0)))&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double AdjudicatorSAN::System_OK_ActActivity::Weight(){ 
  return 1;
}

bool AdjudicatorSAN::System_OK_ActActivity::ReactivationPredicate(){ 
  return false;
}

bool AdjudicatorSAN::System_OK_ActActivity::ReactivationFunction(){ 
  return false;
}

double AdjudicatorSAN::System_OK_ActActivity::SampleDistribution(){
  return 0;
}

double* AdjudicatorSAN::System_OK_ActActivity::ReturnDistributionParameters(){
    return NULL;
}

int AdjudicatorSAN::System_OK_ActActivity::Rank(){
  return 1;
}

BaseActionClass* AdjudicatorSAN::System_OK_ActActivity::Fire(){
  ;
  ;
  System_OK->Mark() = 1;
System_Safe_Failure->Mark() = 0;
System_Unsafe_State->Mark() = 0;
  return this;
}

/*======================System_SS_ActActivity========================*/


AdjudicatorSAN::System_SS_ActActivity::System_SS_ActActivity(){
  ActivityInitialize("System_SS_Act",2,Instantaneous , RaceEnabled, 3,6, false);
}

void AdjudicatorSAN::System_SS_ActActivity::LinkVariables(){
  CH1_OK->Register(&CH1_OK_Mobius_Mark);
  CH2_OK->Register(&CH2_OK_Mobius_Mark);
  System_Safe_Failure->Register(&System_Safe_Failure_Mobius_Mark);
  CH1_Safe_Failure->Register(&CH1_Safe_Failure_Mobius_Mark);
  CH2_Safe_Failure->Register(&CH2_Safe_Failure_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  System_Unsafe_State->Register(&System_Unsafe_State_Mobius_Mark);
}

bool AdjudicatorSAN::System_SS_ActActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((CH1_OK->Mark() == 0) && (CH2_OK->Mark() == 0) && (System_Safe_Failure->Mark() == 0) && ((CH1_Safe_Failure->Mark() != 0) || (CH2_Safe_Failure->Mark() != 0)))&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double AdjudicatorSAN::System_SS_ActActivity::Weight(){ 
  return 1;
}

bool AdjudicatorSAN::System_SS_ActActivity::ReactivationPredicate(){ 
  return false;
}

bool AdjudicatorSAN::System_SS_ActActivity::ReactivationFunction(){ 
  return false;
}

double AdjudicatorSAN::System_SS_ActActivity::SampleDistribution(){
  return 0;
}

double* AdjudicatorSAN::System_SS_ActActivity::ReturnDistributionParameters(){
    return NULL;
}

int AdjudicatorSAN::System_SS_ActActivity::Rank(){
  return 1;
}

BaseActionClass* AdjudicatorSAN::System_SS_ActActivity::Fire(){
  ;
  ;
  System_OK->Mark() = 0;
System_Safe_Failure->Mark() = 1;
System_Unsafe_State->Mark() = 0;
  return this;
}

/*======================System_US_ActActivity========================*/


AdjudicatorSAN::System_US_ActActivity::System_US_ActActivity(){
  ActivityInitialize("System_US_Act",3,Instantaneous , RaceEnabled, 3,5, false);
}

void AdjudicatorSAN::System_US_ActActivity::LinkVariables(){
  CH1_OK->Register(&CH1_OK_Mobius_Mark);
  CH2_OK->Register(&CH2_OK_Mobius_Mark);
  CH1_Safe_Failure->Register(&CH1_Safe_Failure_Mobius_Mark);
  CH2_Safe_Failure->Register(&CH2_Safe_Failure_Mobius_Mark);
  System_Unsafe_State->Register(&System_Unsafe_State_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  System_Safe_Failure->Register(&System_Safe_Failure_Mobius_Mark);
}

bool AdjudicatorSAN::System_US_ActActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((CH1_OK->Mark() == 0) && (CH2_OK->Mark() == 0) && (CH1_Safe_Failure->Mark() == 0) && (CH2_Safe_Failure->Mark() == 0) && (System_Unsafe_State->Mark() == 0)));
  return NewEnabled;
}

double AdjudicatorSAN::System_US_ActActivity::Weight(){ 
  return 1;
}

bool AdjudicatorSAN::System_US_ActActivity::ReactivationPredicate(){ 
  return false;
}

bool AdjudicatorSAN::System_US_ActActivity::ReactivationFunction(){ 
  return false;
}

double AdjudicatorSAN::System_US_ActActivity::SampleDistribution(){
  return 0;
}

double* AdjudicatorSAN::System_US_ActActivity::ReturnDistributionParameters(){
    return NULL;
}

int AdjudicatorSAN::System_US_ActActivity::Rank(){
  return 1;
}

BaseActionClass* AdjudicatorSAN::System_US_ActActivity::Fire(){
  ;
  System_OK->Mark() = 0;
System_Safe_Failure->Mark() = 0;
System_Unsafe_State->Mark() = 1;
  return this;
}

/*======================Common_failureActivity========================*/

AdjudicatorSAN::Common_failureActivity::Common_failureActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Common_failure",0,Exponential, RaceEnabled, 1,4, false);
}

AdjudicatorSAN::Common_failureActivity::~Common_failureActivity(){
  delete[] TheDistributionParameters;
}

void AdjudicatorSAN::Common_failureActivity::LinkVariables(){
  CH1_OK->Register(&CH1_OK_Mobius_Mark);
  CH2_OK->Register(&CH2_OK_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  CCF_enabler->Register(&CCF_enabler_Mobius_Mark);
  CCF_active->Register(&CCF_active_Mobius_Mark);
}

bool AdjudicatorSAN::Common_failureActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((((CH1_OK->Mark() > 0) && (CH2_OK->Mark() > 0) && (System_OK->Mark() > 0) && (CCF_enabler->Mark() > 0))));
  return NewEnabled;
}

double AdjudicatorSAN::Common_failureActivity::Rate(){
  return CC_failure_rate;
  return 1.0;  // default rate if none is specified
}

double AdjudicatorSAN::Common_failureActivity::Weight(){ 
  return 1;
}

bool AdjudicatorSAN::Common_failureActivity::ReactivationPredicate(){ 
  return false;
}

bool AdjudicatorSAN::Common_failureActivity::ReactivationFunction(){ 
  return false;
}

double AdjudicatorSAN::Common_failureActivity::SampleDistribution(){
  return TheDistribution->Exponential(CC_failure_rate);
}

double* AdjudicatorSAN::Common_failureActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int AdjudicatorSAN::Common_failureActivity::Rank(){
  return 1;
}

BaseActionClass* AdjudicatorSAN::Common_failureActivity::Fire(){
  ;
  CCF_active->Mark() = 2;
  return this;
}

