#ifndef Control_configuration_channelSAN_H_
#define Control_configuration_channelSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double C_Rep_Success;
extern double C_Att_Success;
extern double C_fail_det_prob;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               Control_configuration_channelSAN Submodel Definition                   
*********************************************************************/

class Control_configuration_channelSAN:public SANModel{
public:

class Correct_incorrectActivity_case1:public Activity {
public:

  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Correct_Control;
  short* Correct_Control_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_incorrectActivity_case1();
  ~Correct_incorrectActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_incorrectActivity_case1Activity

class Correct_incorrectActivity_case2:public Activity {
public:

  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Correct_Control;
  short* Correct_Control_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;
  Place* Incorrect_Control;
  short* Incorrect_Control_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_incorrectActivity_case2();
  ~Correct_incorrectActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_incorrectActivity_case2Activity

class Repair_control_confActivity_case1:public Activity {
public:

  Place* Incorrect_Control;
  short* Incorrect_Control_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;
  Place* Correct_Control;
  short* Correct_Control_Mobius_Mark;

  double* TheDistributionParameters;
  Repair_control_confActivity_case1();
  ~Repair_control_confActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Repair_control_confActivity_case1Activity

class Repair_control_confActivity_case2:public Activity {
public:

  Place* Incorrect_Control;
  short* Incorrect_Control_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;

  double* TheDistributionParameters;
  Repair_control_confActivity_case2();
  ~Repair_control_confActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Repair_control_confActivity_case2Activity

class Detection_windowActivity_case1:public Activity {
public:

  Place* Incorrect_Control;
  short* Incorrect_Control_Mobius_Mark;
  Place* Configuration_state;
  short* Configuration_state_Mobius_Mark;
  Place* Unsafe_state_2;
  short* Unsafe_state_2_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;
  Place* Correct_Control;
  short* Correct_Control_Mobius_Mark;

  double* TheDistributionParameters;
  Detection_windowActivity_case1();
  ~Detection_windowActivity_case1();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Detection_windowActivity_case1Activity

class Detection_windowActivity_case2:public Activity {
public:

  Place* Incorrect_Control;
  short* Incorrect_Control_Mobius_Mark;
  Place* Unsafe_state_2;
  short* Unsafe_state_2_Mobius_Mark;
  Place* OK_state;
  short* OK_state_Mobius_Mark;
  Place* Safe_failure;
  short* Safe_failure_Mobius_Mark;
  Place* Correct_Control;
  short* Correct_Control_Mobius_Mark;

  double* TheDistributionParameters;
  Detection_windowActivity_case2();
  ~Detection_windowActivity_case2();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Detection_windowActivity_case2Activity

  //List of user-specified place names
  Place* Attack_in_progress;
  Place* Correct_Control;
  Place* Incorrect_Control;
  Place* Unsafe_state_2;
  Place* OK_state;
  Place* Safe_failure;
  Place* Configuration_state;

  // Create instances of all actvities
  Correct_incorrectActivity_case1 Correct_incorrect_case1;
  Correct_incorrectActivity_case2 Correct_incorrect_case2;
  Repair_control_confActivity_case1 Repair_control_conf_case1;
  Repair_control_confActivity_case2 Repair_control_conf_case2;
  Detection_windowActivity_case1 Detection_window_case1;
  Detection_windowActivity_case2 Detection_window_case2;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup Correct_incorrectGroup;  PostselectGroup Repair_control_confGroup;  PostselectGroup Detection_windowGroup;
  Control_configuration_channelSAN();
  ~Control_configuration_channelSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end Control_configuration_channelSAN

#endif // Control_configuration_channelSAN_H_
